module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(1));


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const url = __webpack_require__(2);
const request = __webpack_require__(3);
const Strategy = __webpack_require__(4);
const core_1 = __webpack_require__(5);
function encodeClientInfo(obj) {
    let str = JSON.stringify(obj);
    return new Buffer(str).toString('base64')
        .replace(/\+/g, '-')
        .replace(/\//g, '_')
        .replace(/=+$/, '');
}
const generateOptions = (options) => {
    return Object.assign({}, options, { authorizationURL: url.format({
            protocol: options.protocol || 'https', host: options.domain,
            pathname: `${core_1.AUTH_ENDPOINTS.AUTH_ROOT}${core_1.AUTH_ENDPOINTS.AUTH_AUTHORIZE}`,
        }), tokenURL: url.format({
            protocol: options.protocol || 'https', host: options.domain,
            pathname: `${core_1.AUTH_ENDPOINTS.AUTH_ROOT}${core_1.AUTH_ENDPOINTS.AUTH_TOKEN}`,
        }), userInfoURL: url.format({
            protocol: options.protocol || 'https', host: options.domain,
            pathname: `${core_1.API_ENDPOINTS.AUTH_ROOT}${core_1.API_ENDPOINTS.AUTH_USER_INFO}`,
        }), apiUrl: url.format({ protocol: options.protocol || 'https', host: options.domain, pathname: `/api/v${options.version || 1}` }) });
};
class IdentityServerStrategy extends Strategy.OAuth2Strategy {
    constructor(options, verification) {
        super(generateOptions(options), verification);
        this.name = 'identity';
        this.infoHeaders = encodeClientInfo({ name: 'passport-identity', version: '0.0.1' });
        this.options = generateOptions(options);
    }
    authenticate(req, options) {
        if (req.query && req.query.error) {
            return this.fail(req.query.error);
        }
        return super.authenticate(req, options);
    }
    fail(...data) {
        super.fail(...data);
    }
    _getAccessToken(done) {
        let requestBody = {
            'client_id': this.options.clientID,
            'client_secret': this.options.clientSecret,
            'type': 'web_server',
            'grant-type': 'client_credentails',
        };
        request({
            method: 'POST',
            url: this.options.tokenURL,
            form: requestBody,
            headers: {
                'Identity-Client': this.infoHeaders,
            },
        }, (err, resp, body) => {
            if (err) {
                return done(err);
            }
            const result = JSON.parse(body);
            const accessToken = result['access_token'];
            const idToken = result['id_token'];
            done(null, accessToken, idToken);
        });
    }
    userProfile(accessToken, done) {
        this._oauth2.get(this.options.userInfoURL, accessToken, function (err, body, res) {
            if (err) {
                return done(new Error('Falied to fetch user profile'));
            }
            try {
                const profile = JSON.parse(body);
                done(null, profile);
            }
            catch (e) {
                done(e);
            }
        });
    }
}
exports.IdentityServerStrategy = IdentityServerStrategy;


/***/ }),
/* 2 */
/***/ (function(module, exports) {

module.exports = require("url");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("request");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("passport-oauth");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("@identity-stack/core");

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map