import * as Strategy from 'passport-oauth';
export interface IdentityOptions {
    domain: string;
    clientID: string;
    clientSecret: string;
    callbackURL: string;
    protocol?: string;
    version?: number;
}
export interface IOAuthStrategy {
    authenticate(req: any, options: any): any;
    fail(data: any): any;
}
export declare class IdentityServerStrategy extends Strategy.OAuth2Strategy implements IOAuthStrategy {
    private options;
    private _oauth2;
    name: string;
    private infoHeaders;
    constructor(options: IdentityOptions, verification: any);
    authenticate(req: any, options: any): any;
    fail(...data: any[]): void;
    private _getAccessToken(done);
    userProfile(accessToken: any, done: any): void;
}
